# std::shared_future< _Res > Class Template Reference
[Futures]

Primary template for shared_future. More...

Inheritance diagram for std::shared_future< _Res >:
[legend]

List of all members.

## Public Member Functions

- shared_future (const shared_future &__sf)
- shared_future (shared_future &&__sf)
- shared_future (future< _Res > &&__uf)
- const _Res & get ()
- shared_future & operator= (const shared_future &__sf)
- shared_future & operator= (shared_future &&__sf)
- bool valid () const
- void wait () const
- template<typename _Rep , typename _Period > bool wait_for (const chrono::duration< _Rep, _Period > &__rel) const
- template<typename _Clock , typename _Duration > bool wait_until (const chrono::time_point< _Clock, _Duration > &__abs) const

## Protected Types

- typedef __future_base::_Result
  < _Res > & __result_type
- typedef shared_ptr< _State > __state_type

## Protected Member Functions

- __result_type _M_get_result ()
- void _M_swap (__basic_future &__that)

## Detailed Description

### template<typename _Res>
class std::shared_future< _Res >

Primary template for shared_future.

Definition at line 683 of file future.

## Constructor & Destructor Documentation

template<typename _Res >

std::shared_future< _Res >::shared_future | ( | const shared_future< _Res > & | __sf | ) | `[inline]`

Copy constructor.

Definition at line 691 of file future.

template<typename _Res >

std::shared_future< _Res >::shared_future | ( | future< _Res > && | __uf | ) | `[inline]`

Construct from a future rvalue.

Definition at line 694 of file future.

template<typename _Res >

std::shared_future< _Res >::shared_future | ( | shared_future< _Res > && | __sf | ) | `[inline]`

Construct from a shared_future rvalue.

Definition at line 699 of file future.

## Member Function Documentation

template<typename _Res>

__result_type std::__basic_future< _Res >::_M_get_result | ( |  | ) | `[inline, protected, inherited]`

Wait for the state to be ready and rethrow any stored exception.

Definition at line 513 of file future.

Referenced by std::shared_future< _Res >::get(), std::future< void >::get(), and std::future< _Res >::get().

template<typename _Res >

const _Res& std::shared_future< _Res >::get | ( |  | ) | `[inline]`

Retrieving the value.

Definition at line 717 of file future.

References std::__basic_future< _Res >::_M_get_result().

The documentation for this class was generated from the following file:

- future